﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


namespace MindFusion.Scheduling.Wpf.Samples.CS.UnlimitedScrolling
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			calendar.EndDate += TimeSpan.FromDays(20);
			calendar.VScrollPos = 1;
		}

		void calendar_VScroll(object sender, ScrollEventArgs e)
		{
			if (e.ScrollEventType == ScrollEventType.SmallDecrement ||
				e.ScrollEventType == ScrollEventType.LargeDecrement)
			{
				if (e.NewValue == 0)
				{
					// The decrement doesn't change the scrollbar
					// value, so we must be at the beginning of
					// the view, trying to scroll up
					calendar.Date -= TimeSpan.FromDays(7);
					calendar.EndDate -= TimeSpan.FromDays(7);
					calendar.VScrollPos = 1;
				}
			}

			if (e.ScrollEventType == ScrollEventType.SmallIncrement ||
				e.ScrollEventType == ScrollEventType.LargeIncrement)
			{
				ScrollBar scroller = e.Source as ScrollBar;
				if (e.NewValue == scroller.Maximum)
				{
					// The increment doesn't change the scrollbar
					// value, so we must be at the end of the view,
					// trying to scroll down
					calendar.Date += TimeSpan.FromDays(7);
					calendar.EndDate += TimeSpan.FromDays(7);
					calendar.VScrollPos = scroller.Maximum - 1;
				}
			}

			if (e.ScrollEventType == ScrollEventType.EndScroll)
			{
				if (e.NewValue == 0)
				{
					calendar.Date -= TimeSpan.FromDays(7);
					calendar.EndDate -= TimeSpan.FromDays(7);
					calendar.VScrollPos = 1;
				}

				ScrollBar scroller = e.Source as ScrollBar;
				if (e.NewValue == scroller.Maximum)
				{
					calendar.Date += TimeSpan.FromDays(7);
					calendar.EndDate += TimeSpan.FromDays(7);
					calendar.VScrollPos = scroller.Maximum - 1;
				}
			}
		}
	}
}
